setInfos(8, "BuzzQuiz", "It could be painful to get these questions wrong.","NIFOC99", 
"v0.2", 0xe0e22a, "en", ["game", "formale", "forfemale", "estim"])
//
// v0.1 first version
// v0.2 minor corrections, linux file system (FileName)

def ImgPath = getDataFolder().replaceAll("\\\\", "/")+"images/BuzzQuiz/"
setImage(ImgPath+"BuzzQuiz-000-"+getRandom(3)+".jpg")
def Title = "<h1 style='font-size:140%;'>BuzzQuiz</h1>\n\n"
show(Title+"Welcome to BuzzQuiz.\n\nSick on your electrodes and take this quiz. If you get an answer "+
	"wrong it will be painful for you.\n\nSetting up...")
wait(2)

def Version = "v0.2"
//send("BuzzQuiz.Version", Version)//only for new versions

if(isConnected()&&receiveString("BuzzQuiz.Version")!=Version) {
	show(Title+"This ("+Version+") is not the latest version ("+receiveString("BuzzQuiz.Version")+").")
	wait(3)
	show(Title+"Check for the latest version at ss.deviatenow.com/scripts.php")
	wait(3)
	showButton("OK")
}

if(!loadBoolean("toys.estim")) {
	show(Title+"The script doesn't work without an estim device. Try again later.")
	showButton("OK")
	setImage(null)
	show(null)
	return null
}

//definitions
def QOrder = [
	[0, 1, 2, 3], [0, 1, 3, 2], [0, 2, 1, 3], [0, 2, 3, 1], [0, 3, 1, 2], [0, 3, 2, 1], 
	[1, 0, 2, 3], [1, 0, 3, 2], [1, 2, 0, 3], [1, 2, 3, 0], [1, 3, 0, 2], [1, 3, 2, 0], 
	[2, 0, 1, 3], [2, 0, 3, 1], [2, 1, 0, 3], [2, 1, 3, 0], [2, 3, 0, 1], [2, 3, 1, 0], 
	[3, 0, 1, 2], [3, 0, 2, 1], [3, 1, 0, 2], [3, 1, 2, 0], [3, 2, 0, 1], [3, 2, 1, 0]
	]

def PRound = 4//rounds
def QRound = 5//questions per round
def maxT = 5000//max time (in ms) to get points
def QnAPath = getDataFolder().replaceAll("\\\\", "/")+"scripts/BuzzQuiz/"
def QNumber = []
def QFiles = []
new File(QnAPath).eachFile() {file->
	if(file.isFile()&&file.getAbsolutePath().indexOf(".txt")>0) {QFiles << file.getAbsolutePath()}
}
if(QFiles.size<1) {
	show(Title+"Error! Cannot find question files in scripts/BuzzQuiz")
	showButton("OK")
	show(null)
	setImage(null)
	return null
}
def wrongPath = getDataFolder().replaceAll("\\\\", "/")+"sounds/BuzzQuiz/"
def wrongFiles = []
new File(wrongPath).eachFile() {file->
	if(file.isFile()&&file.getAbsolutePath().indexOf(".mp3")>0) {wrongFiles << file.getAbsolutePath()}
}
if(wrongFiles.size<1) {
	show(Title+"Error! Cannot find sound files in scripts/BuzzQuiz\n\nYou cannot use audio estim!")
	showButton("OK")
	show(null)
	setImage(null)
}

// Read estim variables
if(loadBoolean("BuzzQuiz.EstimAudio")==null) {save("BuzzQuiz.EstimAudio", true)}
if(loadString("BuzzQuiz.EstimPath")==null) {save("BuzzQuiz.EstimPath", System.getProperty("user.dir"))}
if(loadString("BuzzQuiz.EstimStart")==null) {save("BuzzQuiz.EstimStart", "usbcontrol.exe start")} // the command you use to control your device needs to be in the scripts folder
if(loadString("BuzzQuiz.EstimFinish")==null) {save("BuzzQuiz.EstimFinish", "usbcontrol.exe stop")}
if(loadInteger("BuzzQuiz.EstimTime")==null) {save("BuzzQuiz.EstimTime", 500)} //in ms
def EstimAudio = loadBoolean("BuzzQuiz.EstimAudio")
def EstimPath = loadString("BuzzQuiz.EstimPath")
def EstimStart = loadString("BuzzQuiz.EstimStart")
def EstimFinish = loadString("BuzzQuiz.EstimFinish")
def EstimTime = loadInteger("BuzzQuiz.EstimTime")

//player info
def PlayerSex = 0
if(loadBoolean("intro.female")==true) {PlayerSex = 1}
def LScore = loadInteger("BuzzQuiz.LScore")?: 0
def MScore = loadInteger("BuzzQuiz.MScore")?: 0
def TScore = 0
//gender based definitions
def PlayerGender = ["m", "f"]


//Closures (functions)########################################################################################

def getCodes = {C -> //---------------------------------------------------------------------------------------
	def S1 = 0; def S2 = 0; def PList = []
	for(def i=0; i<C.count("|"); i++) {
		S2 = C.indexOf("|", S1)
		PList << C.substring(S1, S2)
		S1 = S2+1
	}
	return PList
}

def makeCode = {def Ltext ->//--------------------------------------------------------------------------------
	def t = ""
	for(def k=0; k<Ltext.size; k++) {t = t+Ltext[k]+"|"}
	return t		
}

def setupEstim = {//-------------------------------------------------------------------------------------------
	setImage(ImgPath+"BuzzQuiz-005-"+PlayerSex+".jpg")
	if(!getBoolean(Title+"You have to attach your estim device somewhere below the waist. Make it somewhere "+
		"sensitive!", "Done", "Setup estim")) {
		if(getBoolean(Title+"Is your estim device worked by audio inputs?")) {
			setImage(ImgPath+"BuzzQuiz-006-0.jpg")
			EstimAudio = true
			if(wrongFiles.size<1) {
				show(Title+"Error! Cannot find sound files in sounds/BuzzQuiz\n\nYou cannot use audio estim. Try again with "+
					"directly linked estim, or get some sound files!")
				showButton("OK")
				show(null)
				setImage(null)
				return false
			}
		}
		else {
			setImage(ImgPath+"BuzzQuiz-006-1.jpg")
			EstimAudio = false
// Define the external commands used to control the device
			EstimStart = getString("Make sure your computer is linked to your device with the correct "+
				"commands.\n\nWhat is the command your computer runs to start your device:", EstimStart)
			EstimFinish = getString("What is the command your computer runs to stop your device:",EstimFinish)
			EstimPath = getString("Locatiom of the command file your computer runs to control your device:", 
				EstimPath)
			save("BuzzQuiz.EstimStart", EstimStart)
			save("BuzzQuiz.EstimFinish", EstimFinish)
			save("BuzzQuiz.EstimPath", EstimPath)
		}
		save("BuzzQuiz.EstimAudio", EstimAudio)
	}
//testing
	def e = true
	while(e) {
		if(EstimAudio) {
			setImage(ImgPath+"BuzzQuiz-006-0.jpg")
			if(getBoolean(Title+"You should test the level!\n\nDon't continue until you're sure your "+
				"device is working." ,"TEST", "Continue")) {
				playBackgroundSound("courtroom/elec_chair.mp3")
				wait(1)
				playBackgroundSound(null)
			}
			else {e = false}
		}
		else {
			setImage(ImgPath+"BuzzQuiz-006-1.jpg")
			if(getBoolean("You should do a quick test first!\n\nDon't continue until you're sure your "+
					"device is working.", "TEST", "Continue")) {
				try {
					useFile(EstimPath+"/"+EstimStart)
					wait(2)
					useFile(EstimPath+"/"+EstimFinish)
					wait(1)
				}
				catch(def e1) {
					show(Title+"There was an error. You will need to set up again.")
					showButton("OK")
					show(null)
					setImage(null)
					return false
				}
			}
			else {e = false}
		}
	}
	return true
}

def getCorrect = {T1 ->//---------------------------------------------------------------------------------------
	def T2 = maxT-(new Date().getTime()-T1)
	if(T2<0) {T2=0}
	setImage(ImgPath+"BuzzQuiz-001-"+getRandom(3)+".jpg")
	show(Title+"<b>CORRECT</b>")
	wait(1)
	return T2
}

def getWrong = {//----------------------------------------------------------------------------------------------
	setImage(ImgPath+"BuzzQuiz-002-"+getRandom(3)+".jpg")
	show(Title+"<b>WRONG</b>")
	wait(getRandom(200)/100+0.1)
	if(EstimAudio) {playSound(wrongFiles[getRandom(wrongFiles.size)])}
	else {
		try {
			useFile(EstimPath+"/"+EstimStart)
			wait(getRandom(EstimTime-50)/100+0.5)
			useFile(EstimPath+"/"+EstimFinish)
		}
		catch(def e1) {
			show(Title+"Error!")
			wait(2)
			return
		}
	}
	wait(getRandom(200)/100+0.1)
}

def showInstructions = {//-------------------------------------------------------------------------------------
	setImage(ImgPath+"BuzzQuiz-004-"+getRandom(2)+".gif")
	if(getBoolean(Title+"Before playing, you should attach the electrodes of your estim device somewhere sensitive below"+
		"your waist. You will be asked "+PRound+" questions in "+QRound+" rounds. Each time you get a question wrong, you "+
		"will get a shock to punish your stupidity. All the questions are on general knowledge. Your score at the end of "+
		"each round is calculated from the speed of your answers.", "OK", "Advanced settings")) {return}
	else {
		show(Title+"You can add your own questions in the folder '/scripts/BuzzQuiz'. All question files in that folder "+
			"will be included in BuzzQuiz provided they are in a file with an extension '.txt'. Files with any other "+
			"extension will be ignored. There should be one question per line, with no blank lines. Each question meeds to be "+
			"formatted as:\nID|Question|Correct|Wrong|Wrong|Wrong|\nID must be unique within the file; the separators "+
			"are '|', vertical bar, ASCII 007C. Questions cannot contain | or \\, and non-ASCII (e.g. accented letters) "+
			"may not be handled correctly. You need to give the correct answer directly after the question, and then three "+
			"alternative wrong answers. Don't forget the | at the end of the line\n\nRun the script "+
			"BuzzQuizQuestionTest.groovy to test new files of questions.")
		showButton("Next")
		EstimTime = getInteger(Title+"If you use an audio estim, you can include .mp3 files in the folder '/sounds/BuzzQuiz'. "+
			"When you get a question wrong, BuzzQuiz will use one of the files to punish you. Only .mp3 files work, files "+
			"with any other extension are ignored.\n\nIf you use a direct-control estim, you must set up control files for "+
			"BuzzQuiz to use. Your punishment will last up to "+EstimTime+" milliseconds. Input a new maximum.", EstimTime)
		save("BuzzQuiz.EstimTime", EstimTime)
	}
}

//Start ######################################################################################################

while(true) { // repeat until return
	setImage(ImgPath+"BuzzQuiz-000-"+getRandom(3)+".jpg")
	switch(getSelectedValue(Title+"You will answer questions, and if you get them wrong, you will be punished."+
		"\n\nYour most recent score was "+LScore+", your best score is "+MScore+"\n\nDo you agree to this?", 
		["I agree", "No, I'm leaving!", "Instructions"])) {
			
		case 0: // yes - play
		//-----
		if(!getBoolean(Title+"Ready to play? First you need to set up the estim device", "OK", 
			"No let me out")) {
			setImage(null)
			show(Title+"See you again soon!")
			wait(1)
			setImage(null)
			show(null)
			return null
		}
		if(!setupEstim()) {
			setImage(null)
			setImage(null)
			show(null)
			return null
		}

		QNumber= []
		def QScore = []
		def T1, T2
		for(def j=0; j<PRound; j++) {
			T2 = 0
			def r0 = getRandom(QFiles.size)
			while(QFiles[r0]==null) {r0 = getRandom(QFiles.size)}
			def FileName = ""
			if(QFiles[r0].indexOf("/")<0) {
				FileName = QFiles[r0].reverse().substring(0, QFiles[r0].reverse().indexOf("\\")).reverse()
			}
			else {
				FileName = QFiles[r0].reverse().substring(0, QFiles[r0].reverse().indexOf("/")).reverse()
			}
			def QnALine = new File(QFiles[r0]).readLines()
			for(def i=0; i<QRound; i++) {
				setImage(ImgPath+"BuzzQuiz-000-"+getRandom(3)+".jpg")
				def r3 = getRandom(QnALine.size)
				def z = 0
				while(QnALine[r3].indexOf("|")<0) {r3 = getRandom(QnALine.size)}
				def QnAList = getCodes(QnALine[r3])
				while(FileName+"["+QnAList[0]+"]" in QNumber||QnALine[r3].indexOf("|")<0||z>1000) {
					r3 = getRandom(QnALine.size)
					QnAList = getCodes(QnALine[r3])
					z++
				}
				QNumber << FileName+"["+QnAList[0]+"]"
				def r1 = getRandom(24)
				T1 = new Date().getTime()
				def r2 = getSelectedValue("<p style='font-size:80%;'>"+FileName+"["+QnAList[0]+"]</p>"+
					Title+"<b>Round "+(j+1)+" Question "+(i+1)+"</b>\n\n"+QnAList[1], 
					[QnAList[2+QOrder[r1][0]], QnAList[2+QOrder[r1][1]], 
					QnAList[2+QOrder[r1][2]], QnAList[2+QOrder[r1][3]]])
					if(QOrder[r1][r2]==0) {T2 = T2+getCorrect(T1)}
					else {getWrong()}
			}
			QScore << T2/QRound
			setImage(ImgPath+"BuzzQuiz-003-"+getRandom(5)+".jpg")
			if(!getBoolean(Title+"End of round "+(j+1)+"\n\nScore "+QScore[j]+"\n\nContinue?")) {
				setImage(null)
				show(Title+"Can't take it? Try again soon!")
				wait(1)
				setImage(null)
				show(null)
				return null
			}
		}
		for(def k=0; k<PRound; k++) {TScore = TScore+QScore[k]}
		TScore = TScore/PRound
		def m = Title+"Your final score is this time "+TScore+"\n"
		if(TScore>LScore) {m = m+"Great! You beat your last score of "+LScore+"\n"}
		else{m = m+"You need to try again! beat Your last score was "+LScore+"\n"}
		LScore = TScore
		if(TScore>MScore) {
			m = m+"Congratulations! You have a new all-time best!"
			MScore = TScore
		}
		else{m = m+"Your all-time best is still "+LScore}
		show(m)
		showButton("OK")
		save("BuzzQuiz.LScore", LScore)
		save("BuzzQuiz.MScore", MScore)
		break
		case 1: // Leave
		//-----
		setImage(null)
		show(Title+"Bye!")
		wait(1)
		setImage(null)
		show(null)
		return null
		break
		case 2: // Control
		//-----
		showInstructions()
		break
	}
}
// This script, from http://ss.deviatenow.com, is protected by this licence :
// CC BY-SA 4.0, see http://creativecommons.org/licenses/by-sa/4.0/
/*
 * Resources
 * scripts/BuzzQuiz.groovy
 * scripts/BuzzQuizQuestionTest.groovy
 * scripts/BuzzQuiz/*.txt
 * images/BuzzQuiz/BuzzQuiz*.jpg
 * images/BuzzQuiz/BuzzQuiz*.gif
 * sounds/BuzzQuiz/*.mp3
 * sounds/courtroom/elec_chair.mp3
 */
